<template>
  <div class="navbar">
    <hamburger :is-active="sidebar.opened" class="hamburger-container" @toggleClick="toggleSideBar" />

    <breadcrumb v-if="showBreadcrumb" class="breadcrumb-container" />

    <!-- <NavMenu class="navmenu" /> -->

    <div class="right-menu">
      <!-- <div class="right-menu-item hover-effect">
        <el-tooltip effect="dark" content="家用工程机登录" placement="bottom">
          <i
            class="el-icon-s-platform"
            style="font-size: 24px; line-height: 50px"
            @click="toEngine"
          ></i>
        </el-tooltip>
      </div> -->
      <div style="margin: 0 20px">
          <el-autocomplete
            v-model="pathurl"
            :fetch-suggestions="querySearchAsync"
            placeholder="搜索菜单"
            @select="handleSelect"
          ></el-autocomplete>
        </div>
      <div v-if="isHongGe" class="right-menu-item" style="display: flex">
        <el-select v-model="changeNum" filterable :disabled="!isHongGe" @change="handleChangeArea">
          <el-option v-for="item in areaOpti" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </div>
      <!-- <div class="right-menu-item hover-effect" style="display: flex" @click="handleShow">
        <el-badge>
          <i class="el-icon-message-solid" style="font-size: 24px; line-height: 50px" />
        </el-badge>
        <span style="font-size: 16px; margin-left: 15px">物流通知</span>
      </div> -->
      <div class="right-menu-item hover-effect" style="display: flex" @click="handleNotice">
        <el-badge value="示">
          <i class="el-icon-message-solid" style="font-size: 24px; line-height: 50px" />
        </el-badge>
        <span style="font-size: 16px; margin-left: 15px">物流到货通知</span>
      </div>
      <div class="right-menu-item hover-effect" @click="toEngine">
        <i class="el-icon-s-platform" style="font-size: 18px" />
        <span style="font-size: 16px; margin-left: 6px">家用工程机登录</span>
      </div>

      <el-badge :value="noticeCount" :max="10" :hidden="!noticeVisible" class="right-menu-item hover-effect">
        <el-tooltip effect="dark" content="系统消息" placement="bottom">
          <i class="el-icon-message-solid" style="font-size: 24px; line-height: 50px" @click="goNotice" />
        </el-tooltip>
        <!-- <el-button icon="el-icon-message-solid" type="text" class="notice-icon" @click="goNotice"></el-button> -->
      </el-badge>
      <template v-if="device !== 'mobile'">
        <screenfull id="screenfull" class="right-menu-item hover-effect" />
      </template>

      <el-dropdown class="user-container" trigger="click">
        <div class="user right-menu-item hover-effect">
          <i class="el-icon-user-solid" />
          <span>{{ name }}</span>
        </div>
        <el-dropdown-menu slot="dropdown" class="user-dropdown">
          <router-link to="/setting/personal">
            <el-dropdown-item>个人信息</el-dropdown-item>
          </router-link>
          <el-dropdown-item divided @click.native="logout">
            <span style="display: block">退出登录</span>
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>

    <el-dialog title="绑定工程机系统" :visible.sync="dialogFormVisible" :modal="false" width="30%">
      <el-form ref="engineForm" :model="engineForm" :rules="engineFormRules">
        <el-form-item label="账号" :label-width="formLabelWidth" prop="account">
          <el-input v-model="engineForm.account" placeholder="请输入账号" autocomplete="off" />
        </el-form-item>
        <el-form-item label="密码" :label-width="formLabelWidth" prop="password">
          <el-input v-model="engineForm.password" placeholder="请输入密码" autocomplete="off" show-password />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
    <!--    工程机多帐号-->
    <!--    <el-dialog-->
    <!--      title="绑定工程机系统"-->
    <!--      :visible.sync="dialogFormVisible"-->
    <!--      :modal="false"-->
    <!--      width="60%"-->
    <!--    >-->
    <!--      <el-form ref="engineForm" :model="engineForm">-->
    <!--        <el-row v-for="(row, index) in engineForm.engineList" :key="row.id" :gutter="20">-->
    <!--          <el-col :span="8">-->
    <!--            <el-form-item-->
    <!--              :label="'账号' + (index+1)"-->
    <!--              :label-width="formLabelWidth"-->
    <!--              :prop="'engineList.' + index + '.enginUserName'"-->
    <!--              :rules="{required: true, message: '请输入工程机账号', trigger: 'blur'}"-->
    <!--            >-->
    <!--              <el-input v-model="row.enginUserName" placeholder="请输入账号" autocomplete="off"></el-input>-->
    <!--            </el-form-item>-->
    <!--          </el-col>-->
    <!--          <el-col :span="8">-->
    <!--            <el-form-item-->
    <!--              :label="'密码' + (index+1)"-->
    <!--              :label-width="formLabelWidth"-->
    <!--              :prop="'engineList.' + index + '.enginPassword'"-->
    <!--              :rules="{required: true, message: '请输入工程机密码', trigger: 'blur'}"-->
    <!--            >-->
    <!--              <el-input v-model="row.enginPassword" placeholder="请输入密码" autocomplete="off" show-password></el-input>-->
    <!--            </el-form-item>-->
    <!--          </el-col>-->
    <!--          <el-col :span="8">-->
    <!--            <template v-if="row.adminUserId">-->
    <!--              <el-button @click="submitForm(index)">重验</el-button>-->
    <!--            </template>-->
    <!--            <template v-else>-->
    <!--              <el-button @click="submitForm(index)">验证</el-button>-->
    <!--            </template>-->

    <!--            <el-button v-if="row.adminUserId" @click="toEngine(index)">打开</el-button>-->
    <!--            <el-button @click="delAccountForm(index)">删除</el-button>-->
    <!--          </el-col>-->
    <!--        </el-row>-->
    <!--      </el-form>-->
    <!--      <div slot="footer" class="dialog-footer">-->
    <!--        <el-button @click="addRowEngine">新增账号</el-button>-->
    <!--        <el-button @click="dialogFormVisible = false">取 消</el-button>-->
    <!--      </div>-->
    <!--    </el-dialog>-->
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import Breadcrumb from '@/components/Breadcrumb'
import Hamburger from '@/components/Hamburger'
import Screenfull from '@/components/Screenfull'
import NavMenu from '@/components/NavMenu'
import { getNoticeListCount } from '@/api/notice'
import { getNoticeList } from '@/api/stock'
import { getListOrderTrack } from '@/api/supply/pickup'
import { getListInvoiceOrder } from '@/api/dashboard'
import { pages } from '@/settings'

import { bindEngineAccount, checkEngineAccount, setUserChanging } from '@/api/setting'
import mixin from '@/mixin'

export default {
  components: {
    Breadcrumb,
    Hamburger,
    Screenfull,
    // eslint-disable-next-line vue/no-unused-components
    NavMenu
  },
  mixins: [mixin],
  data() {
    return {
      pathurl: '',
      noticeType: 1,
      intivalId: '',
      timer: '',
      noticeCount: 0,
      userInfo: '',
      engineForm: {
        account: '',
        password: ''
        // engineList: []
      },
      engineFormRules: {
        account: [{ required: true, message: '请输入工程机账号', trigger: 'blur' }],
        password: [{ required: true, message: '请输入工程机密码', trigger: 'blur' }]
      },
      formLabelWidth: '100px',
      dialogFormVisible: false,
      // websocket错误连接次数
      wsConnectErrorTime: 1,
      websock: null,
      lockReconnect: false,
      noticeList: [],
      form: {
        specification: ''
      },
      isLogistics: false,
      visible: false,
      orderId: '',
      logisticsDetail: [],
      invoiceOrderList: [],
      currentPage: 1, // 当前页码
      pageSize: 10, // 每页数量
      listTotal: 0, // 列表总数
      currentPage2: 1, // 当前页码
      pageSize2: 10, // 每页数量
      listTotal2: 0, // 列表总数
      myType: '',
      changeNum: 1,
      areaOpti: [
        { label: '弘格', value: 1 },
        { label: '广州', value: 2 },
        { label: '佛山', value: 3 }
      ]
    }
  },
  mounted() {
    // 浏览器不同标签页监听
    // window.addEventListener('storage', event => {
    //   if (event.key === 'user_auto_num') {
    //       this.$router.go(0)
    //   }
    // })
    this.changeNum = this.autoChangeNum
    // const that = this
    // 开定时器轮询未读消息接口(写在全局vuex里比较好)
    // that.initNotice();
    // that.tcMessage();
    // this.intivalId = setInterval(function () {
    //   that.tcMessage();
    // }, 5000);
    // this.timer = setInterval(function () {
    //   that.initNotice();
    // }, 3000);
    // 长链接
    // this.initWebSocket();
  },
  created() {
    this.userInfo = JSON.parse(localStorage.getItem('supply_user'))
  },
  beforeDestroy() {
    window.clearInterval(this.intivalId)
    window.clearInterval(this.timer)
    this.websocketOnclose()
  },
  // eslint-disable-next-line vue/order-in-components
  computed: {
    showBreadcrumb() {
      return this.$store.state.settings.breadcrumb
    },
    noticeVisible() {
      return this.noticeCount > 0
    },
    hasNotice: {
      get() {
        // 数据为空是不展示消息通知弹框
        if (!this.noticeList.length && !this.myType) {
          return false
        } else {
          // if (this.noticeList.length) {
          //   return true
          // }
          return this.isNotice
        }
      },
      set(e) {
        return e
      }
    },
    ...mapGetters(['sidebar', 'avatar', 'device', 'name', 'isNotice', 'isCustomer', 'isHongGe', 'autoChangeNum'])
  },

  methods: {
    getList() {
      // this.getNoticeList()
    },

    querySearchAsync(queryString, cb) {
      var data = pages.filter(item => ~item.meta.title.indexOf(queryString))
      cb(
        data.map(item => ({
          value: item.meta.title,
          path: item.path
        }))
      )
    },
    handleSelect(item) {
      if (item.path) {
        this.$router.push({
          path: item.path
        })
      }
      this.pathurl = ''
    },
    handleChangeNotice(e) {
      if (e === 2) {
        this.currentPage2 = 1
        this.pageSize2 = 10
        this.listTotal2 = 0
        this.getNoticeList()
      } else {
        this.pageSize = 10
        this.currentPage = 1
        this.listTotal = 0
        this.getListInvoiceOrder()
      }
    },
    getNoticeList() {
      // this.listLoading = true
      getNoticeList({
        pageNum: this.currentPage2,
        pageSize: this.pageSize2,
        specification: this.form.specification
      }).then(res => {
        console.log(res.data.records, '999')
        this.noticeList = res.data.records
        this.listTotal2 = res.data.total
        // this.listLoading = false
      })
    },
    getNoticeLists() {
      // this.listLoading = true
      getNoticeList({
        pageNum: 1,
        pageSize: this.pageSize2,
        specification: this.form.specification
      }).then(res => {
        this.noticeList = res.data.records
        this.listTotal2 = res.data.total
        // this.listLoading = false
      })
    },
    // 获取物流列表
    getListInvoiceOrder(data) {
      // this.listLoading = true

      getListInvoiceOrder({
        pageSize: this.pageSize,
        pageNum: this.currentPage
      }).then(res => {
        this.invoiceOrderList = res.data.records
        this.listTotal = res.data.total
        // this.listLoading = false
      })
    },
    handleNotice() {
      this.$store.commit('user/showMessage', 'yes')
    },
    toggleSideBar() {
      this.$store.dispatch('app/toggleSideBar')
    },
    async logout() {
      await this.$store.dispatch('user/logout')
      // this.$router.push(`/login?redirect=${this.$route.fullPath}`)
      this.$store.commit('tagsView/SET_RESET_VIES')
      this.$router.push(`/login`)
    },
    initNotice() {
      getNoticeListCount().then(res => {
        if (res.data > 0 && this.noticeCount !== res.data) {
          this.noticeCount = res.data
        } else if (res.data === 0 && this.noticeCount !== res.data) {
          this.noticeCount = 0
        }
      })
    },
    // async tcMessage() {
    //   // 长链接
    //   // let data = {
    //   //   type: 'RebateOrderMsg',
    //   //   params: {
    //   //   }
    //   // }
    //   // this.websocketSend(JSON.stringify(data))
    //   let res = await getRebateOrderMsg();
    //   if (res.data.hasMessage) {
    //     this.$notify.info({
    //       title: "消息",
    //       message: res.data.messages,
    //       position: "bottom-right",
    //       duration: 4000,
    //       showClose: false,
    //     });
    //   }
    // },
    goNotice() {
      this.$router.push('/notice')
    },
    openEngineAccount() {
      this.engineForm.engineList = this.userInfo.bindEnginList
      this.dialogFormVisible = true
    },
    toEngine() {
      const userInfoCopy = this.userInfo
      if (userInfoCopy && userInfoCopy.bindEngin) {
        checkEngineAccount().then(res => {
          if (res.code === 200) {
            // this.$refs.engineSubmit.click()
            const { href } = this.$router.resolve({
              name: 'open_engin'
            })
            window.open(href, '_blank')
          } else {
            this.$errorMsg('账号密码错误，请重新绑定')
            this.dialogFormVisible = true
          }
        })
      } else {
        this.dialogFormVisible = true
      }
    },
    // toEngine(index) {
    //   工程机多帐号
    //   const { href } = this.$router.resolve({
    //     name: "open_engin",
    //     query: {
    //       index: index
    //     }
    //   });
    //   window.open(href, "_blank");
    // },
    // addRowEngine() {
    //   this.engineForm.engineList.push({
    //     adminUserId: '',
    //     enginPassword: '',
    //     enginUserName: '',
    //     status: '',
    //   })
    // },
    submitForm() {
      this.$refs.engineForm.validate(valid => {
        if (valid) {
          const params = {
            enginUserName: this.engineForm.account,
            enginPassword: this.engineForm.password
          }
          bindEngineAccount(params).then(res => {
            if (res.code === 200) {
              this.$successMsg('绑定成功，正在打开工程机系统')
              this.dialogFormVisible = false
              this.$store.dispatch('user/getInfo').then(() => {
                this.userInfo = JSON.parse(localStorage.getItem('supply_user'))
                const { href } = this.$router.resolve({
                  name: 'open_engin'
                })
                window.open(href, '_blank')
              })
            } else {
              this.$errorMsg(res.message)
            }
          })
        }
      })
    },
    // submitForm(index) {
    //   工程机多帐号
    //   this.$refs.engineForm.validate((valid) => {
    //     if (valid) {
    //       const params = {
    //         enginUserName: this.engineForm.engineList[index].enginUserName,
    //         enginPassword: this.engineForm.engineList[index].enginPassword,
    //         isReset: this.engineForm.engineList[index].adminUserId !== ''
    //       };
    //       bindEngineAccount(params).then((res) => {
    //         if (res.code === 200) {
    //           this.$successMsg("绑定成功，工程机系统");
    //           this.$store.dispatch("user/getInfo").then(() => {
    //             this.userInfo = JSON.parse(localStorage.getItem("supply_user"));
    //             this.engineForm.engineList = this.userInfo.bindEnginList
    //           });
    //         } else {
    //           this.$errorMsg(res.message);
    //         }
    //       });
    //     }
    //   });
    // },
    // delAccountForm(index) {
    //   if (this.engineForm.engineList[index].id) {
    //     this.$confirm('此操作将删除账号, 是否继续?', '提示', {
    //       confirmButtonText: '确定',
    //       cancelButtonText: '取消',
    //       type: 'warning',
    //       center: true
    //     }).then(() => {
    //       delEngineAccount({id: this.engineForm.engineList[index].id}).then(() => {
    //         this.$store.dispatch("user/getInfo").then(() => {
    //           this.userInfo = JSON.parse(localStorage.getItem("supply_user"));
    //           this.engineForm.engineList = this.userInfo.bindEnginList
    //         });
    //         this.$successMsg("删除成功");
    //       })
    //     }).catch(() => {
    //     });
    //   } else {
    //     this.engineForm.engineList.splice(index, 1)
    //   }
    // }
    initWebSocket: function() {
      // WebSocket与普通的请求所用协议有所不同，ws等同于http，wss等同于https
      // var userId = this.$store.getters.userid;
      //
      // var url = process.env.VUE_APP_BASE_API.replace("https://","wss://").replace("http://","ws://").replace("api","supply")+"websocket/"+userId;
      // console.debug(userId, url);
      // let token = getToken()
      // this.websock = new WebSocket(url, [token]);
      // this.websock.onopen = this.websocketOnopen;
      // this.websock.onerror = this.websocketOnerror;
      // this.websock.onmessage = this.websocketOnmessage;
      // this.websock.onclose = this.websocketOnclose;
    },
    websocketOnopen: function() {
      console.debug('WebSocket连接成功')
      // 心跳检测重置
      // this.heartCheck.reset().start();
    },
    websocketOnerror: function(e) {
      console.debug('WebSocket连接发生错误，第%s次', this.wsConnectErrorTime)

      this.wsConnectErrorTime = this.wsConnectErrorTime + 1
      if (this.wsConnectErrorTime > 5) {
        console.debug('WebSocket连接错误超过5次，就不再重新连了！')
        this.lockReconnect = true
        return
      }

      this.reconnect()
    },
    websocketOnmessage: function(e) {
      console.debug('-----接收消息-------', e.data)
      // eslint-disable-next-line no-eval
      const data = eval('(' + e.data + ')') // 解析对象
      if (data.type === 'RebateOrderMsg') {
        if (data.res.hasMessage) {
          this.$notify.info({
            title: '消息',
            // eslint-disable-next-line no-undef
            message: res.data.messages,
            position: 'bottom-right',
            duration: 4000,
            showClose: false
          })
        }
      }
    },
    websocketOnclose: function(e) {
      console.debug('connection closed (' + e + ')')
      if (e) {
        console.debug('connection closed (' + e.code + ')')
      }
      this.reconnect()
    },
    websocketSend(text) {
      // 数据发送
      try {
        this.websock.send(text)
      } catch (err) {
        console.debug('send failed (' + err.code + ')')
      }
    },
    reconnect() {
      var that = this
      if (that.lockReconnect) return
      that.lockReconnect = true
      // 没连接上会一直重连，设置延迟避免请求过多
      setTimeout(function() {
        console.debug('尝试重连...')
        that.initWebSocket()
        that.lockReconnect = false
      }, 20000)
    },

    // handleShow() {
    //   ;(this.isLogistics = true), this.getListInvoiceOrder()
    // },
    // 更改每页数量
    handleSizeChange2(val) {
      this.pageSize2 = val
      this.currentPage2 = 1
      this.getNoticeList()
    },
    // 更改当前页
    handleCurrentChange2(val) {
      this.currentPage2 = val

      this.getNoticeList()
    },
    // 更改每页数量
    handleSizeChange(val) {
      this.pageSize = val
      this.currentPage = 1
      this.getListInvoiceOrder()
    },
    // 更改当前页
    handleCurrentChange(val) {
      this.currentPage = val

      this.getListInvoiceOrder()
    },
    handLogistics(row) {
      getListOrderTrack({ orderId: row.id }).then(res => {
        this.logisticsDetail = res.data
      })
      this.orderId = row.id
      this.visible = true
    },
    onClose() {
      this.logisticsDetail = []
      this.orderId = ''
      this.visible = false
    },
    handleJump(id) {
      this.$router.push({ path: `/supply/pickup/sum_list?id=${id}` })
      this.$store.commit('user/SET_STATUS', false)
    },
    handleChangeArea(changeNum) {
      setUserChanging({ changeNum }).then(res => {
        this.$router.go(0)
        this.$successMsg('切换成功')
      })
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~@/styles/variables.scss';
.right-menu-item {
  ::v-deep .el-input__inner {
    width: 80px;
    font-size: 16px;

    color: #333333;
    border: 0 !important;
  }
}

::v-deep .is-fixed {
  right: 10px !important;
}

.flex {
  margin-top: 30px;
  display: flex;
  align-items: center;
  justify-content: space-between;
}

.navbar {
  width: 100%;
  height: 50px;
  overflow: hidden;
  background: #{$navbarBg};
  box-shadow: 0 1px 4px rgba(0, 21, 41, 0.08);

  .hamburger-container {
    line-height: 46px;
    height: 100%;
    color: #{$navbarText};
    float: left;
    cursor: pointer;
    transition: background 0.3s;
    -webkit-tap-highlight-color: transparent;
    border-right: 1px solid #eaeaea;

    &:hover {
      background: rgba(0, 0, 0, 0.025);
    }
  }

  .navmenu {
    float: left;
  }

  .breadcrumb-container {
    float: left;
  }

  .right-menu {
    float: right;
    height: 100%;
    line-height: 50px;

    & > div {
      float: left;
    }

    &:focus {
      outline: none;
    }

    .user-container {
      height: 50px;

      .user {
        i {
          font-size: 18px;
          margin-right: 5px;
        }

        span {
          font-size: 16px;
        }
      }
    }

    .right-menu-item {
      display: inline-block;
      padding: 0 15px;
      height: 100%;
      font-size: 18px;
      color: #{$navbarText};
      vertical-align: text-bottom;
      border-left: 1px solid #eaeaea;

      &.hover-effect {
        cursor: pointer;
        transition: background 0.3s;

        &:hover {
          background: rgba(0, 0, 0, 0.025);
        }
      }

      .notice-icon {
        padding-top: 0;
        padding-bottom: 0;
      }
    }
  }
}
</style>

<style lang="scss">
.navbar {
  .right-menu {
    .right-menu-item {
      .notice-icon > i {
        font-size: 18px;
      }

      sup {
        top: 12px;
        right: 25px;
      }
    }
  }
}
.tip {
  margin: 50px auto;
  text-align: center;
}
</style>
